"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initaliseRateLimiter = void 0;
var rate_limiter_flexible_1 = require("rate-limiter-flexible");
var utils_1 = require("./utils");
var initaliseRateLimiter = function (_a) {
    var limiterStore = _a.limiterStore, limiter = _a.limiter, limiterOptions = _a.limiterOptions, rateLimiterID = _a.rateLimiterID;
    if (!limiterOptions)
        return null;
    if (limiter.mongoClient) {
        return initialiseMongoLimiter({
            limiterStore: limiterStore,
            mongoClient: limiter.mongoClient,
            mongoOptions: limiter.limiterOptions,
            limiterOptions: limiterOptions,
            rateLimiterID: rateLimiterID,
        });
    }
    throw new Error("Limiter failed to be created for \"" + limiterOptions.keyPrefix + "\", no valid limiter found (mongo currently only valid option)");
};
exports.initaliseRateLimiter = initaliseRateLimiter;
var initialiseMongoLimiter = function (_a) {
    var limiterStore = _a.limiterStore, mongoClient = _a.mongoClient, mongoOptions = _a.mongoOptions, limiterOptions = _a.limiterOptions, rateLimiterID = _a.rateLimiterID;
    var points = limiterOptions.points, duration = limiterOptions.duration, keyPrefix = limiterOptions.keyPrefix;
    /* Duration accepts m/h/d shorthand, multiply by the appropriate value */
    var valDuration = utils_1.getTimeFromString(duration);
    if (limiterStore[rateLimiterID]) {
        throw new Error("Duplicate keyprefix \"" + keyPrefix + "\" found, cannot create rate limiter");
    }
    var rateLimiterOpts = __assign({ storeClient: mongoClient, points: points, duration: valDuration, keyPrefix: keyPrefix }, mongoOptions);
    return new rate_limiter_flexible_1.RateLimiterMongo(rateLimiterOpts);
};
